/**
 * This is common js for intercept with Android Application
 * Version 1.0.3
 */

(function() {

	// 判断window对象中是否存在"my"，如果不存在，注册命名空间 'my' 到window对象上
	if(undefined == window['my']){
		window['my'] = {}

		connectWebViewJavascriptBridge(function(bridge) {
            bridge.init(function(message, responseCallback) {
                console.log('JS got a message', message);
                var data = {
                    'Javascript Responds': '测试中文!'
                };
                console.log('JS responding with', data);
                responseCallback(data);
            });
        })

	}

	 function connectWebViewJavascriptBridge(callback) {
         if (window.WebViewJavascriptBridge) {
             callback(WebViewJavascriptBridge)
         } else {
             document.addEventListener(
                 'WebViewJavascriptBridgeReady'
                 , function() {
                     callback(WebViewJavascriptBridge)
                 },
                 false
             );
         }
     }

	// ---------- call Android Application from js---------------------


	function postMessage(data, invokeOnMessage) {
	    customOnMessage = invokeOnMessage;

		if(window.Native){
				Native.postMessage(data);
			}else if(window.WebViewJavascriptBridge){
				window.WebViewJavascriptBridge.callHandler(
						'Native.postMessage'
						, data
						, function(responseData) {}
					);
			}else{
				throw new Error('J2J env init error');
			}
	}
	// ---------- onMessage start

    /**
     * 自定义返回方式后被触发的回调
     */
    customOnMessage = function(data){
		alert(data);
	};

    /**
     * 调用设置装载自身的Activity的Actionbar的返回功能为自定义方式
     */
    function onMessage(data) {
    	customOnMessage(data);
    }

	// --------- onMessage end

	// 把函数注册到命名空间中
	//调用扩展能力postMessage, webview确定token挂上后触发h5端的具体业务请求
	window['my']['postMessage'] = postMessage;
	//h5的通过my.onMessage()定义回调function
	window['my']['onMessage'] = onMessage;
})();